import os,sys
import socket
import gtk, gobject
import sweetgtk

IMG = 'img'
VERSION = '2.0'

class TrayIcon(gtk.StatusIcon):
    def __init__(self, window):
        self.sweetgtk = window
        self.win_visible = True
        self.win = window.window
        gtk.StatusIcon.__init__(self)
        menu = '''
                <ui>
                <menubar name="Menubar">
                <menu action="Menu">
                <menuitem action="Config"/>
                <menuitem action="About"/>
                <menuitem action="Quit"/>
                </menu>
                </menubar>
                </ui>
        '''
        actions = [
                ('Menu',  None, 'Menu'),
                ('Config', gtk.STOCK_PREFERENCES, '_Config...', None,
                    'Configure', self.on_config),
                ('About', gtk.STOCK_ABOUT, '_About...', None,
                    'About sweetgtk', self.on_about),
                ('Quit',gtk.STOCK_QUIT,'_Quit',None,
                    'Quit sweetgtk', self.on_quit),

                ]
        ag = gtk.ActionGroup('Actions')
        ag.add_actions(actions)
        self.manager = gtk.UIManager()
        self.manager.insert_action_group(ag, 0)
        self.manager.add_ui_from_string(menu)
        self.menu = self.manager.get_widget('/Menubar/Menu/About').props.parent
        self.current_icon_path = ''
        gtk.StatusIcon.set_from_file(self, os.path.join(IMG,
            "sweetlogo.png"))
        self.set_visible(True)
        self.connect('popup-menu', self.on_popup_menu)
        self.connect('activate', self.on_click)

    def on_quit(self,widget):
        sys.exit()

    def on_popup_menu(self, status, button, time):
        self.menu.popup(None, None, None, button, time)

    def on_about(self, data):
        dialog = gtk.AboutDialog()
        dialog.set_name('SweetGTK')
        dialog.set_version(VERSION)
        dialog.set_comments('Interactua con Sweetter desde tu escritorio')
        dialog.set_website('http://sweetter.net')
        dialog.set_logo(gtk.gdk.pixbuf_new_from_file(os.path.join(IMG,
            'poweredby.png')))
        dialog.run()
        dialog.destroy()

    def on_config(self, data):
        ret = self.sweetgtk.show_config()

    def on_click(self, data=None):
        if self.win_visible:
            self.win_visible = False
            self.win.hide()
        else:
            self.win_visible = True
            self.win.show()

    def set_blinking(self, boolean):
        if boolean == False:
            gtk.StatusIcon.set_from_file(self, os.path.join(IMG,
                "sweetlogo.png"))
        else:
            gtk.StatusIcon.set_from_file(self, os.path.join(IMG,
                "sweetlogo-invert.png"))
