import twitter
import urllib
import datetime
from pysweetter import Comment
import locale
locale.setlocale(locale.LC_ALL, (None, None))
gmt = 1

class Twitter:
    def __init__(self, user='', passwd=''):
        self.authenticate(user, passwd)

    def authenticate(self, user='', passwd=''):
        self.api = twitter.Api(username=user, password=passwd)

    def post(self, text):
        self.api.PostUpdate(text)

    def get_last_comments(self, user):
        lasts = self.api.GetUserTimeline(user)
        return self._parse_twitts(lasts)

    def get_last_followings(self, user):
        lasts = self.api.GetFriendsTimeline(user)
        return self._parse_twitts(lasts)

    def _parse_twitts(self, list_of_twitts):
        comments = []
        for twitt in list_of_twitts:
            created = twitt.created_at_in_seconds + 3600 * gmt
            sweet = twitt.text
            user = twitt.user.screen_name
            avatar = twitt.user.profile_image_url
            avatar = urllib.quote(avatar.encode('utf8'), safe=':/')

            comments.append(Comment(sweet, user, avatar, created))

        return comments
